<?php
//dd - version 1.2 - 25/03/2007
/* hypothèses générales :
	- util.inc.php est inclus par l'appelant,
	- la session a été démarrée
*/

class pagination {
	var $existait;		// (privée) en sortie de constructeur indique l'état trouvé
	var $limit; 		// (privée) le 1er param du LIMIT de mysql
	var $nbDonnees;		// (privée)
	var $pageAct;		// (privée)
	var $premier;		// (privée) n° première page affichée dans la pagination
	var $dernier;		// (privée) n° dernière page affichée dans la pagination
	var $lastPage;		// (privée) n° (absolu) de la dernière page 
	var $varGet; 		// (privée) nom de la variable du GET (après le '?' de l'url)
	var $varPost; 		// (privée) nom de la variable POST si l'accès direct est utilisé
	var $ident;			// (privée) nom de la variable de session = "session_$varGet"
	var $select;		// (privée) n° de la page sélectionnée
	var $query;			// (privée) requête (sans LIMIT)

	var $nbDonneesParPage;
	var $nbNumeros;		// nombre de numéros affichés
	var $url;			// en principe et par défaut la même page (privée ??)
	var $sep;			// pour séparer les pages (- ou | ou autre éventuel)
	var $nbEspaces;		// nombre d'espaces avant et après le séparateur
	var $libPremiere,	// libellés
		$libPrecedente,
		$libSuivante,
		$libDerniere;

function reinit($nbdata=-1) {
$this->existait=0;			// correspond au cas 1
$this->select=1; 			// pageAct calculée plus tard
$this->premier=1; 			// dernier calculé plus tard
$this->nbDonnees=$nbdata; 	// $nbdata=-1 signale qu'on n'a pas encore calculé le nb de données
}

function init($nbdata=-1) {
$this->url=basename($_SERVER['PHP_SELF']);
$this->nbDonneesParPage=20;
$this->nbNumeros=10;
$this->sep='|';
$this->nbEspaces=2;
$this->libPremiere='&lt;&lt;&nbsp;';
$this->libPrecedente='&lt;&nbsp;';
$this->libSuivante='&nbsp;&gt;';
$this->libDerniere='&nbsp;&gt;&gt;';
$this->reinit($nbdata);	
}
	
function pagination($varGet='selectedpage') {
//on récupère les éventuelles données en session sauf si $ident est connu en session
$this->varGet=$varGet;
$this->varPost=$varGet.'_direct';
$this->ident='session_'.$varGet; //identificateur de la zone de stockage dans la session

	// D'où vient-on ?
	// 	1- on ne vient pas de cette page 
	//	  	a) premier passage sans jamais y être passé dans la session
	//		b) on est déjà venu là puis allé ailleurs... mais la session est restée	
	//	2- on vient de cette page et on veut garder les mêmes données (n° page notamment) car 
	//		a) on a fait un clic sur un numéro de page
	//		b) on a choisi directement un n° de page
	//		c) on ne veut pas réinitialiser car la page va s'afficher comme au passage précédent
	//	3- on vient de cette page et on veut réinitialiser comme pour le premier passage (=ancienne valeur)
	// Les cas 1 et 2 seront corrects en sortie du constructeur
	// Seul le cas 3 nécessitera donc une réinitialisation (mettre à 1 l'attribut select)
	// Ce sera par exemple le cas si on réordonne les résultats affichés (ordre, nombre).

$this->existait=1;
if (isset($_SESSION[$this->ident])) {
    //print "<br />";print"cas 1b ou 2 ou 3 : on est déjà passé dans cette page"; print "<br />";
    $phpSelf=parseUrl($_SERVER['PHP_SELF'],'path');
    $phpReferer=parseUrl(@$_SERVER['HTTP_REFERER'],'path');
    if ($phpSelf==$phpReferer) {
		//print "<br />";print"cas 2 ou 3 : on ne pourra pas trancher ici, le prog appelant le fera"; print "<br />"; 
		$otemp=unserialize($_SESSION[$this->ident]); //on ne peut pas affecter directement $this
	    foreach(get_object_vars($otemp) as $champ => $valeur) {
			$this->$champ = $valeur;
			}
		//la boucle précédente a réaffecté $this->existait de l'ancienne valeur (false au passage 2). On rectifie. 
		$this->existait=1;
		//print "<br />"; print "post = ";print_r($_POST); print "<br />";
		//print "<br />"; print "get = ";print_r($_GET); print "<br />";
		if (isset($_POST[$this->varPost])) {
			//il faut commencer par lui (priorité)
			//print "<br />";print"cas 2 avec accès direct"; print "<br />"; 
			$this->select=(int) $_POST[$this->varPost];
			}
		elseif (isset($_GET[$this->varGet])) {
			//print "<br />";print"cas 2 avec clic sur page"; print "<br />";
			//print_r($_GET); print "<br />";
			$this->select=(int) $_GET[$this->varGet];
			}
		else {
			$this->existait=-1; // cas ambigu :
			//print "<br />";print"cas 2 provenant d'une autre action dans la page OU car 3 : (def. cas 2)"; print "<br />"; 
			// on prend par défaut le cas 2 (donc l'ancien $this->select)
			// si on prend au contraire $this->select=1 ce serait le cas 3, ce que pourra 
			// faire le prog appelant s'il a plus de renseignements 
			}
		}
	else {
		//print "<br />";print"cas 1b : on est déjà passé... mais pas juste avant"; print "<br />";
		//effacer un éventuel passage antérieur dans cette page 
		//mais garder le même paramétrage
		unset($_SESSION[$this->ident]);
		$this->init();  
		//si on fait réinit au lieu d'init, on se plante avec les sessions rémanentes...
		//... avec le même navigateur 
		}
	} 
else {
	//cas 1a
	$this->init();
	}	
}



function getPageSelected() {
if (isset($_POST[$this->varPost]))
	$sel=(int) $_POST[$this->varPost];
elseif (isset($_GET[$this->varGet])) 
	$sel=(int) $_GET[$this->varGet];
else $sel=1;

if (!is_numeric($sel)) $sel=1;
else {
	$sel=(int) $sel;
	if ($sel<=0) $sel=1;
	}
return $sel;	
}


function setNbDonnees($nb=-1) {
$this->nbDonnees=$nb;
}
		

function calculerBornes() {
//calculer la valeur réelle de pageAct en fonction du lien cliqué
$this->lastPage=ceil((int) $this->nbDonnees/$this->nbDonneesParPage);
$this->dernier=min($this->premier + $this->nbNumeros -1, $this->lastPage);
	
switch ($this->select) {
	case -4 : 	//clic sur Première
				$this->pageAct=1;	
				break;
	case -3 :   //clic sur Précédente
				if ($this->pageAct>1) $this->pageAct--; 
				break;	
	case -2 : 	//clic sur Suivante
				if ($this->pageAct<$this->lastPage) $this->pageAct++; 
				break;
	case -1 :	//clic sur Dernière
				$this->pageAct=$this->lastPage;
				break;
	default :   $this->pageAct=$this->select;
	}

//recalculer premier et dernier	
if ($this->pageAct<$this->premier || $this->pageAct>=$this->dernier) {
	$this->premier=max(1 , $this->pageAct - (int) floor($this->nbNumeros/2));
	$this->dernier=min($this->premier + $this->nbNumeros - 1,$this->lastPage);
	//print "<br><b>$this->premier</b><br>";
	}
//else : rien, tout va bien.
$this->limit=($this->pageAct-1)*$this->nbDonneesParPage;
$_SESSION[$this->ident]=serialize($this);
}


function execQuery($sql) {
$this->query=$sql;
if ($this->nbDonnees==-1) {
	//première fois que la requête de base $this->query est exécutée : pas de LIMIT possible
	$res=query($this->query);
	$this->nbDonnees=mysql_num_rows($res);
	$this->calculerBornes();
	}
else {	
	$this->calculerBornes();
	$res=query("$this->query LIMIT $this->limit , $this->nbDonneesParPage");
	}
return $res;
}


//affiche la liste des pages
function affichePagination($messageAvant='') {
if ($this->premier==$this->dernier) return; //une seule page
$espaces=str_repeat('&nbsp;',$this->nbEspaces);
$trou=$espaces.$this->sep.$espaces;
$lien='<a href="'.$this->url;
if (strpos($this->url,'?')===false) $lien.='?';
else $lien.='&';
$lien.=$this->varGet.'=%d'.'" >%s</a>';
print "<form href=\"$this->url\" method=\"post\">\n"; //pas toujours utilisé mais obligatoire avant sinon passage à la ligne
print $messageAvant;
if ($this->pageAct!=1) {
	printf($lien.$espaces,1,$this->libPremiere);
	printf($lien.$espaces,$this->pageAct-1,$this->libPrecedente);
	}
for ($i=$this->premier ; $i<=$this->dernier ; $i++) {
	if ($i==$this->pageAct) print "<i><b>$i</b></i>";
	else printf($lien,$i,$i);
	if ($i<$this->dernier) echo $trou;
	}
if ($this->pageAct!=$this->lastPage) {
	printf($espaces.$lien,$this->pageAct+1,$this->libSuivante);
	printf($espaces.$lien,$this->lastPage,$this->libDerniere);
	}
if ($this->lastPage>2*$this->nbNumeros) {
	echo $espaces,$espaces;
	print "<input type=\"text\" name=\"$this->varPost\" size=\"5\" title=\"Accès direct à une page\">\n";
	} 
print "</form>";

}

} //classe pagination
/*
 
///////////////////////////////////////////////////////////////////////////////////////////////////
//Exemple (sortir le délimiteur de remarque en début de ligne et son homologue en fin de script)
///////////////////////////////////////////////////////////////////////////////////////////////////

//Utilisation simple

include('../include/vars_adm.php');
include('../include/util.inc.php'); //ne sert que pour query dans la classe pagination 
connecte($host,$user,$mdp,$db);		//et pour connecte ici

session_start();
//=====================
$pg=new pagination();
//=====================

if (!$pg->existait) {
	//modifier éventuellement les valeurs par défaut ou les autres paramètres publics	
	$pg->nbDonneesParPage=25;
	}


//=====================
$res=$pg->execQuery("SELECT nom, prenom FROM eleves where nom>'A' ");
//=====================


print "<br />";
$cpt=0; //sert seulement pour le premier passage car la 1ère requête n'a pas pu indiquer de LIMIT
while ($row = mysql_fetch_array($res)) {
	if ($cpt++>=$pg->nbDonneesParPage) break;
	echo $row['nom'],' - ',$row['prenom'],'<br />';
	}

print "<br />";

//=====================
$pg->affichePagination(' :: ');
//=====================
*/
?>