<?php
#=
/****************************************************************************
Copyright 2002, Daniel Deycard, Jacques Messines, Stéphanie Roussel, Jean-Marie Treins
(CATICE Académie de Bordeaux)

This file is part of Gibii.

Gibii is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Gibii is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Gibii; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/

//combo des opérandes gauches
$tchampFiltre=array(	array('0',		' - choisir - '),
						array('quand',	'date',),
						array('ip',		'IP'), 
						array('statut',	'statut'),
						array('nom',	'Nom'),
						array('prenom',	'prénom'),
						array('rne',	'RNE'),
						array('cp',		'C.P. étab')
					);
					

//combo des opérateurs				
$topFiltre=array(		array('0',			' - choisir - '),
						array('inferieur',	'&lt ou ='),
						array('egal',		'='),
						array('superieur',	'&gt ou ='),
						array('comme',		'comme')
				);

//les champs affichés
$coltri=array('quand','ip','machinecliente','statut','login','nom', 'prenom','rne','etab','lieu');

//leur invocation dans les compléments de la requête (WHERE et ORDER BY)
$table=array ('quand','connexions.ip','machinecliente','comptes.statut','comptes.login','IFNULL(eleves.nom,profs.nom)','IFNULL(eleves.prenom,profs.prenom)','etablissements.rne','etab','lieu');

$sql0="SELECT   quand, 
                connexions.ip, 
                connexions.machinecliente, 
                connexions.compte_id, 
                login, 
                statut, 
                IFNULL(eleves.nom,profs.nom) AS nom, 
                IFNULL(profs.prenom,eleves.prenom) AS prenom,
                etablissements.etab_id, 
                rne,
                etablissements.nom AS etab, 
                CONCAT( codepostal, ' - ', ville ) AS lieu
        FROM connexions
        LEFT JOIN comptes ON comptes.compte_id = connexions.compte_id
        LEFT JOIN etablissements ON etablissements.etab_id = comptes.etab_id
        LEFT JOIN eleves ON eleves.compte_id = connexions.compte_id
        LEFT JOIN profs ON profs.compte_id = connexions.compte_id";


function tradIP($nip) { 
return long2ip($nip); 
}

function recup($nomSelect,$defaut) {
if (isset($_POST[$nomSelect])) {  			//POST a priorité ici
	$valSelected=$_POST[$nomSelect];
	$_SESSION[$nomSelect]=$valSelected;
	}
elseif (isset($_SESSION[$nomSelect])) {		//ensuite, on regarde SESSION
	$valSelected=$_SESSION[$nomSelect];
	}
else $valSelected=$defaut;
return $valSelected;
}
	

function affCombo($nomSelect,$tcombo) {
//	<option value="quand" <?php print $tselchamp['quand'];  >date</option>
print "<select name=\"$nomSelect\" size=\"1\">\n";
for ($i=0 ; $i<count($tcombo) ; $i++) {
	$valSelected=recup($nomSelect,'0');
	$value=$tcombo[$i][0];
	$libelleOption=$tcombo[$i][1];
	print "valeur($i)=$value, valselected=$valSelected"; print "<br />";
	if ($value==$valSelected) $select="selected=\"selected\"";
	else $select="";
	print "<option value=\"$value\" $select>$libelleOption</option>\n";
	}
print "</select>\n";
return $valSelected;
}
					 	

function filtre($champ,$op,$val) {
global $coltri, $table;
//$champ 	:	date,ip,statut,nom,prenom,login,rne,cp
//$op		:	inferieur, egal, superieur, comme
$statuts=array('e'=>'Eleve', 'p'=>'Prof', 'g'=>'Gestion', 'a'=>'Admin', 's'=>'Sadmin');
$opSql='';
switch ($op) {
	case 'inferieur': 	$opSql=' <= '; break;
	case 'egal': 		$opSql=' = '; break;
	case 'superieur': 	$opSql=' >= '; break;
	case 'comme':		$opSql=' LIKE ';
						$val=str_replace(array('?','*'),array('_','%'),$val);
						break;
	}

//print "op=$op opSql=$opSql"; print "<br />";

if (!$opSql) return '';

$cond='';
$p=array_search($champ,$coltri);
if ($p===false) return '';
else $champSql=$table[$p]; //traduction de champ par nomTable.nomChamp
switch ($champ) {
	case 'quand':
	case 'nom':
	case 'prenom':
	case 'login':
	case 'rne':
	case 'cp':
		$cond=$champSql.$opSql."'".secs($val)."'";
		break;
	case 'statut': 
		if ($val) {
			if ($op=='comme') alert("Opérateur [comme] non géré avec le statut");
			else {
				$first=$val[0];
				if (isset($statuts[$first])) $cond=$champSql.$opSql."'".$statuts[$first]."'";
				else alert("Valeur [$val] inconnue pour le statut. Attendu : e|p|g|a|s");
				}
			}
		else alert("Le statut ne peut pas être vide. Attendu : e|p|g|a|s");
		break;
	case 'ip':
		if ($val) {
			$tip=explode('.',$val);
			if (count($tip)>4) alert("Trop de champs dans l'adresse IP.");
			else {
				for ($i=0; $i<min(4,count($tip)); $i++) {
					$octet=$tip[$i];
					if ($octet=='%') {
						for ($j=$i; $j<4 ; $j++) $tip[$j]=0;	
						break;    //de la boucle
						}
					elseif (!is_numeric($octet) || $octet>255 || $octet<0) { 
						alert("Adresse IP incorrecte près de [$octet].");
						break 2;  // sortie du switch
						}
					else $tip[$i]= (int) $octet;
					}
				if ($op=='comme' || count($tip)<4) $opSql=">="; //le count pour le cas IP='123' par exemple (champ(s) manquant(s))
				for ($i=count($tip); $i<4 ; $i++) $tip[$i]=0;
				//Les 4 octets sont affectés et sont corrects
				//mettre IP sous forme numérique attendue par MySQL
				$nip=0;
				for ($i=0; $i<4; $i++) $nip=256*$nip + $tip[$i];
				//SELECT ip, (ip + 0x100000000) & 0xFFFFFFFF FROM `connexions`
				$cond="(($champSql + 0x100000000) & 0xFFFFFFFF) $opSql $nip";  
				} 			
			}
		else alert("L'adresse IP ne peut pas être vide.");
		break;
	}	
return $cond;	
}

function th($texte,$paramCol,$paramAlt) {
global $script;
print "<th>
		$texte<br />
		<a href=\"$script?col=$paramCol&ord=a\" >
		<img src=\"../include/images/haut.png\" width=\"14\" height=\"14\" alt=\"tri croissant des $paramAlt\" />
		</a>
		<a href=\"$script?col=$paramCol&ord=d\" >
		<img src=\"../include/images/bas.png\" width=\"14\" height=\"14\" alt=\"tri décroissant des $paramAlt\" />
		</a>
		</th>\n";
}

//==============  Programme principal  ====================
include ("../include/vars_adm.php");
include ("../include/util.inc.php");
include ("../include/utiljs.php");
include ("../include/trifiltre.class.php");
include ("../include/pagination.class.php");
opensession("Sadmin",false);
if ($sess_login=='admstats') {
    aneantir_session();
    goto("./index.php");
    }
//connecte($host,$user,$mdp,$db);

$script=basename($_SERVER['PHP_SELF']);

//pas d'affichage avant (car session_start dans pagination)

//========================================================================
	$pg=new pagination();
//========================================================================

if ($sess_login=='admstats') {
    aneantir_session();
    goto("./index.php");
    }
set_time_limit(240);

?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
<title>Connexions au site</title>
<script language="JavaScript">
</script>
<link rel="stylesheet" href="../include/general.css" />
<link rel="stylesheet" type="text/css" href="../include/trifiltre.css">
</head>
<body class="arial_sadmin">

<?php




print "<h2>Connexions</h2><hr />";

/*
print "<br />POST=";
print_r($_POST);
print "<br />GET=";
print_r($_GET);
print "<br />";
*/


print "<form action=\"$script\" method=\"post\" title=\"Filtrer les résultats\" style=\"position:absolute; width:50em\">";
//obligé de faire un premier test pour affecter convenablement les choix du filtre (avant les affCombo)
//le 2e test sur annuler sera refait plus bas
if (isset($_POST['annuler'])) {
	//corriger
	$_POST['champFiltre']='0';
	$_POST['opFiltre']='0';
	$_POST['valeurFiltre']='';
	}

$champFiltre=affCombo('champFiltre',$tchampFiltre);
$opFiltre=affCombo('operateurFiltre',$topFiltre);
$valeurFiltre=recup('valeurFiltre','');
?>

<input type="text" size="30" maxlength="40" 
	name="valeurFiltre" value="<?php print $valeurFiltre; ?>"
	onMouseOver="var d=document.getElementById('aide'); d.style.visibility='visible';"
	onMouseOut="var d=document.getElementById('aide'); d.style.visibility='hidden';" />
<input type="submit" name="filtrer" value="Filtrer" title="Utiliser le filtre" />
<input type="submit" name="annuler" value="Annuler" title="Effacer le filtre" />
</form>	
<div id="aide" style="position:relative; width:20% ; top:-3em ; left:15em ; background-color:#FFFACD ; visibility:hidden">
Avec l'opérateur "comme", les caractères * et ? sont des jokers
</div>

<?php

if (isset($_POST['annuler'])) {
	//annuler le filtre
	if (isset($_SESSION['where']) && $_SESSION['where']) {
		//il faut réinitialiser le nb de données car il y avait une condition sur la requête
		$pg->setNbDonnees($nblignes=mysql_num_rows(query($sql0)));
		}
	$_SESSION['where']='';
	$_SESSION['orderBy']='';
	}
elseif (isset($_POST['filtrer'])) {
	$condition=filtre($champFiltre,$opFiltre,$valeurFiltre);
	if ($condition) {
		$_SESSION['where']=" WHERE $condition ";
	    $pg->setNbDonnees($nblignes=mysql_num_rows(query($sql0.$_SESSION['where'])));
		}
	else $_SESSION['where']='';
	}
elseif (isset($_POST['chgt_nblignes'])) {
	//modification du nbre de lignes par page
	$nb=(int) $_POST['chgt_nblignes'];
	if ($nb>5) $pg->nbDonneesParPage=$nb;
	}
elseif (isset($_GET['col']))  {
    //clic en tête de tableau (ordonner le tableau donc reprendre la pagination au début)
    //-----------------------------------------------------------------------------------
    //print "<br>cas 3 : réinitialiser select=1 comme pour le premier passage<br>";
    // c'est le cas 3 du constructeur de la classe pagination (on est déjà venu et il faut réinitialiser)
    $pg->init($pg->nbDonnees); //garder le nb de données (pas changé à part les nouvelles connexions !!!) 
    $p=array_search($_GET['col'],$coltri);
    if ($p===false) $_SESSION['orderBy']='';  //par défaut
    else {
		if (isset($_GET['ord']) && $_GET['ord']=='d') $sens=' DESC ';
		else $sens=' ';
		$_SESSION['orderBy']=' ORDER BY '.$table[$p].$sens; //user a cliqué en tête de la colonne GET['col']
		}
	}
elseif ($pg->existait==0) {
    //cas 1 : premier passage
    //---------------
    //print "<br>cas 1 : premier passage car pg->existait==0<br>";
    //$nblignes ne sert en principe pas dans la suite (sauf si besoin particulier du programmeur
    // alternative : calculer les données par une requête plus simple
	$pg->nbDonneesParPage=10;
	$pg->nbNumeros=15;
    $pg->setNbDonnees($nblignes=mysql_num_rows(query("SELECT * FROM connexions")));
    //modifier éventuellement les valeurs par défaut ou les autres paramètres publics   
	$_SESSION['where']='';
	$_SESSION['orderBy']='';
    }
else {
    //cas 2 
    //print "<br>cas 2 : déjà venu et pg->select=$pg->select n'a pas besoin d'être modifié (=ancienne valeur)<br>";
    //et on vient de cette même page 
    }   

print "<div style=\"position:absolute ; top:0px ; left:50%\">";
print "Condition : ".$_SESSION['where']; print "<br />";
print "Tri : ".$_SESSION['orderBy']; print "<br />";
print "</div>";

$sql=$sql0.$_SESSION['where'].$_SESSION['orderBy'];

//=====================
$res=$pg->execQuery($sql);
//=====================

//entre execQuery et affichePagination, on n'a plus le droit de modifier les propriétés de pagination 
//(il faudrait mettre toutes les propriétés private et écrire des méthodes Set...)

print "<div class=\"tf\">";

print "<br /><table border=\"1\">";
print "<thead>";
print "<tr>";
th('Date Heure','quand','dates');
th('IP','ip','adresses');
th('Machine','machinecliente','machines');
th('Statut','statut','statuts');
th('Nom','nom','noms');
th('Prénom','Prénom','prénoms');
th('Login','login','logins');
th('RNE','rne','RNE');
th('Etablissement','etab','établissements');
th('Ville','lieu','cp-ville');
print "</tr> </thead>\n";

$k=0;
while ($row = mysql_fetch_array($res)) {
    $statut=$row['statut'];
    $login=$row['login'];
    $nom=$row['nom'];
    $prenom=$row['prenom'];
    $etab_id=$row['etab_id'];
    if ($nom==NULL) $nom='&nbsp;';
    if ($prenom==NULL) $prenom='&nbsp;';
    if ($statut==NULL) $statut='&nbsp;'; 
    if ($login==NULL) $login='&nbsp;'; 
    if ($etab_id==NULL) {
        $rne=$etab=$lieu='&nbsp;';
        }
    else {
        $rne=$row['rne'];
        $etab=$row['etab'];
        $lieu=$row['lieu'];
        }   
 	$cl=($k%2==0) ? "pair" : "impair";
    $k++;
    
    print '<tr class='.$cl.'>';
    print '<td>'.$row['quand'].'</td>';
    print '<td>'.tradIP($row['ip']).' </td>';
    print '<td>'.$row['machinecliente'].'</td>';
    print '<td>'.$statut.'</td>';
    print '<td>'.$nom.'</td>';
    print '<td>'.$prenom.'</td>';
    print '<td>'.$login.'</td>';
    print '<td>'.$rne.'</td>';
    print '<td>'.$etab.'</td>';
    print '<td>'.$lieu.'</td>';
    print "</tr>\n";
    }

print "</table>\n";

print "</div>";

print "<br />";

//=====================
$pg->affichePagination('Pages : ');
//=====================

print "<form action=\"$script\" method=\"post\">\n";
print " Nombre de lignes par page (actuel : $pg->nbDonneesParPage) : ";
print "<input type=\"text\" name=\"chgt_nblignes\" size=\"4\"/>";
print "<input type=\"submit\" value=\"Modifier\">\n";
print "</form><br />";
?>
</body></html>