<?php
#=
/****************************************************************************
Copyright 2002, Daniel Deycard, Jacques Messines, Alain Pomirol
(CATICE Académie de Bordeaux)

This file is part of Gibii.

Gibii is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Gibii is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Gibii; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/
define("debug",false);
define("TAB","&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
define("DWARN","<span style=\"color:red\"><b>");
define("FWARN","</b></span>");
define("DFAIT","<span style=\"color:red\"><b>");
define("FFAIT",FWARN);
	
include("../include/vars_adm.php");
include("../include/util.inc.php");
include("../include/utiljs.php");
include("../include/attestations.inc.php");
include("../include/get.inc.php");
require_once("../include/define.inc.php");

function printok($mid) {
//affiche un n° de demande ne posant pas de pb obtenu par la requête
if (debug) print "<b>$mid</b> - ";
}

function printDemRep($mid,$code) {
//affiche et corrige les anomalies												// IL FAUT :
static $titre=array('a' => "Ajout d'un résultat",								//m,i,e,d,roi (les rép oui)
					'i' => "Désactivation d'une demande",						//m
					'o' => "Réponses OUI supprimées car redondantes",			//rox
					'n' => "Réponses NON supprimées car redondantes",			//rnx
					'c' => "Cohérence table reponses et champs de la demande"	//nboui,nbnon
					);
global 	$eid,$iid,$did,
		$roui,$rnon, $bilan, 
		$dem_nboui,$dem_nbnon, $dem_date, $dem_active,
		$nomelv,$prenomelv,$classeid,
		$etid, $nbaccetab, $nbrefusetab, $nometab,$codepostal,
		$tnomprof, $tprenomprof,
		$trid, $tpid, $tacc, $tdaterep,
		$trepTropOui, $trepTropNon;
		
print "<br /><br />\n";
print "<fieldset><legend>";
				
print "<span style=\"font-size: 12pt;font-weight: bold;color: Navy;\">\n";
print " | ";
for ($ic=0;$ic<strlen($code);$ic++) echo $titre[$code[$ic]],' | ';
print "\n</span></legend>";

//affichage des renseignements 
print "<b>Etablissement</b> : id=$etid, nom=$nometab - $codepostal, étab_oui=$nbaccetab, étab_non=$nbrefusetab<br />\n";
print "<b>Elève</b> : id=$eid - $nomelv $prenomelv, idclasse=$classeid<br />\n";
if (strpos($code,'i')!==false) {
	query("UPDATE demandes SET active=0 WHERE message_id=$mid");
	$inact=DFAIT." ~> inactivée".FFAIT;
	}
else $inact='';	
print "<b>Demande</b> : id=$mid, bilan=$bilan, it=$iid, disc=$did, 
		date=$dem_date, act=$dem_active, code=$code &nbsp;$inact<br />\n";
print "<b>Réponses</b> : <br />\n";
$nbrep=count($trid);
$tpidOui=array();

for ($r=0;$r<$nbrep;$r++) {
	if ((strpos($code,'o')!==false && in_array($trid[$r],$trepTropOui)) || 
		(strpos($code,'n')!==false && in_array($trid[$r],$trepTropNon))) {
		//la réponse est en trop : elle doit être effacée
		query("DELETE FROM reponses WHERE reponse_id=".$trid[$r]);
		//NB : elle n'était pas comptée dans les cumuls $bilan, $roui ni $rnon donc tout se passe comme si elle n'existait pas
		$msupp=TAB.DFAIT.'<i> ~~> effacée : trop de ';
		if ($code=='o') $msupp.='oui'.FFAIT; else $msupp.='non'.FFAIT;
		}
	else $msupp='';
	if (strpos($code,'a')!==false && !in_array($trid[$r],$trepTropOui) && $tacc[$r]) {
		//il faut ajouter un résultat et conserver les rép OUI pour garnir la table lrp
		$tpidOui[]=$tpid[$r];
		}
	print TAB."- réponse ".($r+1)." : id=".$trid[$r].', idprof='.$tpid[$r].' - '.$tnomprof[$r].'&nbsp;'.$tprenomprof[$r].
			  ', accord='.$tacc[$r].', date='.$tdaterep[$r]. $msupp."<br />\n";
	}
	
if (count($tpidOui)) { // implique qu'on doit ajouter un résultat
	//ajouter le résultat
	$resultat_id=query("INSERT IGNORE INTO resultats SET quand=NOW(), eleve_id=$eid, item_id=$iid, disc_id=$did");
	print DFAIT."Résultat : ajouté.".FFAIT.'<br />';
	//mettre à jour la demande
	query("UPDATE demandes SET obtenue=1, active=0 WHERE message_id=$mid");
	//ajouter les liens lrp
	for ($ro=MIN(count($tpidOui),$nbaccetab)-1 ; $ro=0 ; $ro--) { //on privilégie les derniers OUI
		query("INSERT IGNORE INTO lrp SET quand=NOW(), resultat_id=$resultat_id , prof_id=".$tpidOui[$ro]); 
		}
	//ajouter éventuellement le brevet
	$tacquis=calcule_brevets($eid,false);
	$nbacquis=array_sum($tacquis);
	$nbbrevets=count($tacquis);
	if ($nbacquis) { //on ne sait pas vraiment celui qui est acquis... donc on les fait afficher tous
		print DFAIT."Brevet".pluriel($nbacquis)." acquis : ";
		for ($b=1;$b<=$nbbrevets;$b++) if ($tacquis[$b]) print $b.' '; 
		print FFAIT."<br />\n";
		}
	}

//Cohérence de la demande	
print "<b>Cohérence</b> : \n";
if (strpos($code,'c')!==false) {
	$set='';
	if ($dem_nboui!=$roui) {
		print "accords ~> ".DFAIT."anormal : demandes.nboui=$dem_nboui corrigé par réponses.accord=$roui ".FFAIT;
		}
	if ($dem_nbnon!=$rnon) { 
		print "refus ~> ".DFAIT."anormal : demandes.nbnon=$dem_nbnon corrigé par réponses.refus=$rnon".FFAIT;
		}
	//mettre à jour la demande (ne par toucher aux autres champs qui ont déjà été modifiés éventuellement)
	query("UPDATE demandes SET nboui=$roui, nbnon=$rnon WHERE message_id=$mid");
	}
else print "O.K.";
print "<br />\n";

print "</fieldset><br />\n";
}

//============================
function analyserDemRep($mid) {
global 	$nbrefusetab, $nbaccetab,
		$bilan, $dem_active,
		$trepTropOui, $trepTropNon,
		$dem_nboui, $roui, $dem_nbnon, $rnon;
$code='';
if ($nbrefusetab!=0 && $bilan<=-$nbrefusetab && $dem_active==1) { //si nbrefusetab=0, l'étab accepte un nombre quelconque de refus
	//nombre de refus atteint : la demande n'est pas supprimée à des fins de consultation
	//mais il faut l'inactiver car ce n'est pas déjà fait.
	$code.='i';
    }
if ($bilan>=$nbaccetab) {
    //bilan correct et pas de resultat
	$code.='a';
	}
if (count($trepTropOui)) {
	//il y a des réponses à supprimer pour incohérences (mais sans conséquences
	//sur les résultats ni la demande). On signale quand même la mise en cohérence de la base.
	$code.='o';
	}
if (count($trepTropNon)) {
	//il y a des réponses à supprimer pour incohérences (mais sans conséquences
	//sur les résultats ni la demande). On signale quand même la mise en cohérence de la base.
	$code.='n';
	}
if ($dem_nboui!=$roui || $dem_nbnon!=$rnon) {
	//le nombre de oui dans le champ nboui de la demande diffère du nombre de réponses oui (idem pour NON)
	$code.='c'; //pb de cohérence
	}
 
if (empty($code)) printok($mid);
else printDemRep($mid,$code);
return $code;	
}

function verifdem($mid) {
//les "global" sont :
//  - uniques et relatifs à la demande traitée pour : 
//      eid=eleve_id, iid=item_id, $did=disc_id, nbaccetab, nbrefusetab, etid, datedem
//  - des tableaux pour les profs éventuels : 
//		tpid=prof_id, tacc=accord, tdaterep (éventuellement 1 seule ligne de NULL)

global  $eid,$iid,$did,$etid,
		$dem_date,$dem_active,$dem_obtenue,$dem_nboui,$dem_nbnon,$dem_longue,
		$roui,$rnon,
		$nomelv,$prenomelv,$classeid,
        $trid,$tpid,$tacc,$tdaterep, $trepTropOui, $trepTropNon,$tnomprof,$tprenomprof,
        $nbaccetab,$nbrefusetab,
		$nometab,$codepostal,
		$bilan, $messages, 	//pour rendre global et visible dans les fonctions appelées
		$tinactiver;		//les demandes qui seront inactivées au premier passage, sans intervention du sadmin
$nbrep=count($tpid);
$oldprof=0;
$dejaoui=0;$dejanon=0;
$bilan=0;
$messages='';
$trepTropOui=$trepTropNon=array();
$roui=0;$rnon=0;
for ($i=0 ; $i<$nbrep ; $i++) {
	$prof_id=$tpid[$i];
	$accord=$tacc[$i];
	$daterep=$tdaterep[$i];
	$reponse_id=$trid[$i];
	if ($oldprof==$prof_id) {
		//plusieurs réponses du même prof : on jette sauf si NON puis OUI
		if ($accord) {
			//un même prof ne peut pas donner 2 oui	
			if ($dejaoui) {
				//on évacue la réponse OUI antérieure ($dejaoui)
				$trepTropOui[]=$dejaoui; 
				// ------------------------------------- effacer(réponse $dejaoui)
				}
			else {
				$bilan++;
				$roui++;
				if ($dejanon) {
					$bilan++; //un NON devenu OUI donc +2
					//$rnon--; //ce non doit rester comptabilisé dans $rnon
					}
                //NB : les NON précèdent les OUI (voir requête)    				  
                }
			$dejaoui=$reponse_id; //pour préparer le prochain dans l'ordre chrono
			}
		else {
			//prof_id a répondu NON. A-t-il déjà répondu NON ?
			if ($dejanon) {
				$trepTropNon[]=$dejanon;
				// ------------------------------------- effacer(réponse $dejanon)
				}
			else {
				$bilan--; 
				$rnon++;
				}			
			$dejanon=$reponse_id;
			}
		}
	else {
		//autre prof pour cette demande : tout réinitialiser sauf le bilan et les roui rnon
		$dejaoui=($accord)? $reponse_id:0;
		$dejanon=($accord)? 0:$reponse_id;
		if ($accord)  {
			$bilan++; 
			$roui++;
			}
		else {
			$bilan--;
			$rnon++;
			}
		$oldprof=$prof_id;
		}
	}
$code=analyserDemRep($mid);
return $code;
}


//***************  Programme principal  *********************************************************************
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//***********************************************************************************************************

//----------------------------------------
//"""""""""""""""""""""""""""""""""""""""""
@set_time_limit(600);
opensession('Sadmin',false);
if ($sess_login=='admstats') {
	aneantir_session();
	goto("./index.php");
	}
/*
connecte($host, $user, $mdp,$db);
getparams(false);
recupvars();
*/
//"""""""""""""""""""""""""""""""""""""""""
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
<title>Vérification des demandes et réponses</title>
<link rel="stylesheet" href="../include/general.css" />
<base target="_self" />
<style type="text/css" media="screen">
	.beau {
		font-family: Verdana, Tahoma, Roman;
		font-weight: bold;
		}
</style>
</head>
<body class="arial_sadmin" bgcolor="white" text="black" link="blue" vlink="purple" alink="red">
<h2>Vérification des demandes / réponses</h2>
<hr />
Ne sont étudiées et traitées dans cette vérification que les demandes :
<ul>
	<li>ayant obtenu des réponses (accords ou refus),</li>
	<li>n'ayant pas obtenu de résultat.</li>
</ul>
<p>Les anomalies sont signalées en rouge et corrigées automatiquement. Voici les corrections possibles :
<ul>
	<li>désactivation d'une demande encore active alors que le nombre de refus est atteint </li>
	<li>accord d'un résultat lorsque le bilan est correct (recalcul du brevet)</li>
	<li>suppression de réponses multiples et identiques du même prof</li>
	<li>mise en cohérence du nombre de réponses avec les champs de la table demandes</li>
</ul>
</p><hr>

<?php
$w0=getmicrotime();

$PHP_SELF=basename($_SERVER['PHP_SELF']);


if ($MODULE=='Melia') {
	$AND_discdem=" AND profs.disc_id=demandes.disc_id ";
	$AND_discres=" AND resultats.disc_id=demandes.disc_id ";
	}
else {
	$AND_discdem=' ';
	$AND_discres=' ';
	}

//On ne s'intéresse pas aux demandes ayant abouti à un résultat : elles ne présentent pas de risque ni d'erreur. 
//Et puis... même s'il y a des incohérences, on ne va pas supprimer le résultat !
$sqldemandes="
	SELECT DISTINCT demandes.message_id AS mid,
                    demandes.eleve_id AS eid,
                    demandes.item_id AS iid,
                    demandes.disc_id AS did, 
					demandes.quand AS datedem,
					active,obtenue,nboui,nbnon,longue,
					reponses.reponse_id AS rid,  
					reponses.prof_id AS pid,
					reponses.quand AS daterep, 
					accord, 
					eleves.etab_id AS etid,
					eleves.nom AS nomelv,
					eleves.prenom AS prenomelv,
					eleves.classe_id,
					profs.nom AS nomprof,
					profs.prenom AS prenomprof,
					nb_validations,
					nb_max_refus,
					etablissements.nom AS nometab,
					codepostal

	FROM demandes
		LEFT JOIN reponses ON reponses.message_id = demandes.message_id
		LEFT JOIN profs ON profs.prof_id = reponses.prof_id 
		LEFT JOIN resultats ON resultats.eleve_id=demandes.eleve_id 
				AND resultats.item_id=demandes.item_id
				AND resultats.disc_id=demandes.disc_id 
	, eleves
	, etablissements
	WHERE eleves.eleve_id=demandes.eleve_id
		AND etablissements.etab_id=eleves.etab_id
		AND reponses.prof_id IS NOT NULL 
		AND resultats.resultat_id IS NULL

	ORDER BY etid,mid,pid,daterep,rid";

//à égalité de dates (et, sous entendu, de etid,mid,pid,daterep), utiliser l'indice reponse_id 
//dans la table pour conserver la chronologie.


//lancement de la requête
$w1=getmicrotime();
$res=query($sqldemandes); 
$w2=getmicrotime();

$restant=mysql_num_rows($res);
print "Nombre de demandes vérifiées : $restant</i></p>";
if ($restant==0) {
    print "<h3>Pas d'incohérence dans les demandes / réponses</h3>";
    print "<a href=\"choix_verif.form.php\">Revenir aux vérifications</a>\n";
	print "</body></html>";
	exit();
	}
 

$nbverifs=0;
$tinactiver=array();
$tnbcode=array('a'=>0, 'i'=>0, 'o'=>0, 'n'=>0, 'c'=>0); //ajouter, inactiver, trop oui, trop non, pas cohérent

$row=mysql_fetch_array($res);
while ($row) {
	//initaliser ou réinitialiser les stockages de la requête
	$mid=$row['mid'];
	$eid=$row['eid'];
	$iid=$row['iid'];
	$did=$row['did'];
	$dem_date=$row['datedem'];
	$dem_active=$row['active'];
	$dem_obtenue=$row['obtenue'];
	$dem_nboui=$row['nboui'];
	$dem_nbnon=$row['nbnon'];
	$dem_longue=$row['longue'];
	$etid=$row['etid'];
	$nomelv=$row['nomelv'];
	$prenomelv=$row['prenomelv'];
	$classeid=$row['classe_id'];
	$nometab=$row['nometab'];
	$codepostal=$row['codepostal'];
	$nbaccetab=$row['nb_validations'];
	$nbrefusetab=$row['nb_max_refus'];
	$trid=$tpid=$tacc=$tdaterep=$tnomprof=$tprenomprof=array();
	do  {
		//stocker la réponse
		$trid[]=$row['rid'];
		$tpid[]=$row['pid'];
		$tacc[]=$row['accord'];
		$tdaterep[]=$row['daterep'];
		$tnomprof[]=$row['nomprof'];
		$tprenomprof[]=$row['prenomprof'];
		$row=mysql_fetch_array($res);
		}
	while ($row && $row['mid']==$mid); //$row[$mid] vient d'être réaffecté
	$code=verifdem($mid);
	for ($c=0; $c<strlen($code); $c++) $tnbcode[$code[$c]]++; //on ne compte que les demandes anormales  
	}						

echo "<p>Résultats à ajouter : ",$tnbcode['a'],'<br />';
echo "Demandes à désactiver : ",$tnbcode['i'],'<br />';
echo "Réponse OUI superflues à supprimer : ",$tnbcode['o'],'<br />';
echo "Réponse NON superflues à supprimer : ",$tnbcode['n'],'<br />';
echo "Ajustements des champs de la table demandes : ",$tnbcode['c'],'<br />';

$w3=getmicrotime();

print "</p><p>&nbsp;</p>";
print "<span style=\"font-size: 0.8em;\">";
printf("<p>Requête : %4.2f s <br />",$w2-$w1);
printf("Affichage : %4.2f s </p>",$w3-$w0-($w2-$w1));

print "</span><br /></br><a href=\"choix_verif.form.php\">Revenir aux vérifications</a>\n";
	
?>
</body>
</html>
